<?

# Author: Vincent JAULIN
# Copyright: Keyphrene.com 2008 @ all rights reserved

# Modificado por: jarias. Universidad de Jaén

// function to parse the http auth header
function http_digest_parse($txt)
{
    // protect against missing data
    $needed_parts = array('nonce'=>1, 'nc'=>1, 'cnonce'=>1, 'qop'=>1, 'username'=>1, 'uri'=>1, 'response'=>1);
    $data = array();

    preg_match_all('@(\w+)=([\'"]?)([%a-zA-Z0-9=./\_-]+)\2@', $txt, $matches, PREG_SET_ORDER);

    foreach ($matches as $m) {
        $data[$m[1]] = $m[3];
        unset($needed_parts[$m[1]]);
    }

    return $needed_parts ? false : $data;
}



function AuthenticationBasicHTTP($realm, $users, $phpcgi=0) 
{
	if (empty($_SERVER['PHP_AUTH_USER']) && empty($_SERVER['REDIRECT_REMOTE_USER'])) 
	{
		header('WWW-Authenticate: Basic realm="'.$realm.'"');
		header('HTTP/1.0 401 Unauthorized');
		$needReloadCourses = 1;
		die('401 Unauthorized');
	}


	$user = $_SERVER['PHP_AUTH_USER'];
	if ($phpcgi == 1) 
	{		
		$matches = explode(' ', $_SERVER['REDIRECT_REMOTE_USER']);
		list($name, $password) = explode(':', base64_decode($matches[1]));
		$_SERVER['PHP_AUTH_USER'] = $user = strip_tags($name);
		$_SERVER['PHP_AUTH_PW']    = strip_tags($password);
	}

	//compruebo que el usuario exsite y su password es correcto
	//incluyo la clase para el manejo de la base de datos
	require_once "/var/www/ebook/inc/HTTP/WebDAV/Server/DB.php";

	//conecto con la base de datos
	//MODIFICAR
	$db = new DB("localhost","nombreBD","usuarioBD","passwordBD");		     		     

	$db->connect();     
	$clave = md5(md5($_SERVER['PHP_AUTH_PW']));
	$res = $db->checkUser($_SERVER['PHP_AUTH_USER'],$clave);
	
	if ($res == 1)
	{
		$needReloadCourses = $db->checkLastAccess($_SERVER['PHP_AUTH_USER'],180);
		//creo la sesión
		session_start();
		//guardo el login del usuario para futuros usos
		$_SESSION["userLogin"] = $_SERVER['PHP_AUTH_USER'];

		//guardo los cursos del usuario
		$courses = $db->getCourses($_SESSION["userLogin"]);
		$_SESSION["courses"] = $courses;

		//ahora llamo a la actualizacion de cursos
		if ($needReloadCourses == 1)
		{
			$db->updateLastAccess($_SERVER['PHP_AUTH_USER']);
			//MODIFICAR	
			exec("java -jar /home/usuario/eBookServer_v2.0.jar ".$_SERVER['PHP_AUTH_USER']." ".$_SERVER['PHP_AUTH_PW']." /home/usuario/configEbookServer.xml ".$_SERVER['PHP_AUTH_USER']." >> /var/www/ebook/log/logExecServer.txt &");
		}
		return TRUE;				
	}
	//en caso de que no exsite, compruebo si existe en ilias
	else
	{
		//conecto por SOAP con la funcion LDAP
		try
		{
			$soapclient = new SoapClient("http://dv.ujaen.es/docencia/webservice/soap/server.php?wsdl");
			//crea los parametros necesarios para la llamada a la funcion LDAP			
			$user = $_SERVER['PHP_AUTH_USER'];
			$password = $_SERVER['PHP_AUTH_PW'];

			//llamo a la funcion SOAP		
			$params = array('client' => 'docencia','username' => "$user",'password' => "$password");
			$result = $soapclient->__soapCall('loginLDAP',$params);

			//si no hay exepcion, el usuario exsite, por lo que lo meto en la base de datos
			$clave = md5(md5($_SERVER['PHP_AUTH_PW']));
			//writelog("INSERT INTO student (login,password) VALUES('".$_SERVER['PHP_AUTH_USER']."','$clave');");
			$db->executeQuery("INSERT INTO student (login,password) VALUES('".$_SERVER['PHP_AUTH_USER']."','$clave');");

			//creo la sesión
			session_start();
			//guardo el login del usuario para futuros usos
			$_SESSION["userLogin"] = $_SERVER['PHP_AUTH_USER'];

			//guardo los cursos del usuario
			$courses = $db->getCourses($_SESSION["userLogin"]);
			$_SESSION["courses"] = $courses;

			//ahora llamo a la actualizacion de cursos
			//MODIFICAR
			exec("java -jar /home/usuario/eBookServer_v2.0.jar ".$_SERVER['PHP_AUTH_USER']." ".$_SERVER['PHP_AUTH_PW']." /home/usuario/configEbookServer.xml ".$_SERVER['PHP_AUTH_USER']." >> /var/www/ebook/log/logExecServer.txt &");
			return TRUE;
		}
		catch (SoapFault $exception) 
		{
			//si lanza una excepcion, es que el usuario no existe tampoco en ILIAS
			header('WWW-Authenticate: Basic realm="'.$realm.'"');
			header('HTTP/1.0 401 Unauthorized');
			die('401 Unauthorized');
			return FALSE;
		} 
	}

	header('WWW-Authenticate: Basic realm="'.$realm.'"');
	header('HTTP/1.0 401 Unauthorized');
	die('401 Unauthorized');
	return FALSE;

}

function writelog($message)
{
/*	$fh = fopen('/var/www/ebook/log/aut.log', 'a');
	fwrite($fh, date('Y-m-d H:i:s '));
	fwrite($fh, $message);
	fwrite($fh, "\n");
	fclose($fh);*/
}



?>
