<?php
//
// +----------------------------------------------------------------------+
// | eBookSync v1								  |
// +----------------------------------------------------------------------+
// | Abril 2011                                                           |
// +----------------------------------------------------------------------+
// | Clase para realizar las operaciones sobre la base de datos           |
// | mysql                                                                |
// +----------------------------------------------------------------------+
// | Author: jarias                                                      |        
// +----------------------------------------------------------------------+
//
//

/**
 * Clase para conectar con la base de datos mysql
 * @author jarias@ujaen.es
 * @version 1.0
 */
class DB 
{
    // {{{ Member Variables 
    
    /**
     * Host donde se conectara la base de datos
     * @var string 
     */
    var $_host;

    /**
     * Nombre de la base de datos
     * @var string 
     */
    var $_database;

    /**
     * Usuario de la base de datos
     * @var string 
     */
    var $_user;

    /**
     * Password de la base de datos
     * @var string 
     */
    var $_password;

    /**
     * Es el manejador de la conexion
     * @var string 
     */
    var $_conexion;

	/** 
     * Constructor
     *
     * @param host es el host al que se conectara la base de datos
     * @param database es el nombre de la base de datos a la que nos conectaremos
     * @param user es el usuario con el que accederemos a la base de datos
     * @param password es el password de acceso a la base de datos
     */
	function DB($host,$database,$user,$password) 
    {
		$this->_host = $host;
		$this->_database = $database;
		$this->_user = $user;
		$this->_password = $password;
    }

	/** 
     * Funcion que crea la conexion con la base de datos
     * @param password es el password de acceso a la base de datos
     */
	function connect() 
	{
		$this->conexion = mysql_connect($this->_host,$this->_user,$this->_password);
		mysql_select_db($this->_database, $this->conexion);
	}

	/** 
     * Funcion que realiza un query
     * @param query es la consulta
     */
	function executeQuery($query) 
	{		
		return mysql_query($query, $this->conexion) or die(mysql_error());
	}

	/** 
     * Funcion que devuelve el numero de tuplas de una consulta
     * @param $dataQuery
     */
	function numRowsQuery($dataQuery) 
	{		
		return $this->conectionmysql_num_rows($student_courses);
	}

	/** 
     * Funcion que devuelve el manejador de la conexion
     * @param el manejador de la conexion
     */
	function getConnection() 
	{		
		return $this->conexion;
	}

	/** 
     * Funcion que comprueba si un usuario tiene permiso con respecto a un recurso
     * @param login es el login del usuario
	 * @param fileName es el nombre del recurso a comprobar
     */
	function checkPermission($login,$filename)
	{
		//si el nombre del fichero tiene algo del tipo ref_xxx es que es un curso, lo busco por tanto en la table courses
		$numCount = substr_count($filename,"ref");

		if (substr_count ($filename,"ref") != 0)
		{
			//como tiene ref_xx es la carpeta de un curso, por lo tanto la busco en la tabla cursos.			
			//obtengo los cursos del usuario
			$select = "SELECT * FROM student_course WHERE studentLogin='$login'";
			
			$student_courses = mysql_query($select, $this->conexion) or die(mysql_error());

			//busco si en los resultados, algun curso es como el que estoy buscando
			while ($rowStudentCourse = mysql_fetch_assoc($student_courses)) 
			{
				//compruebo si el curso i es el que estoy buscando
				if (substr_count ($filename,"ref_".$rowStudentCourse['courseId']) != 0)
				{	
					//si no es 0, esque lo he encontrado, por lo tanto devuelvo true.					
					return 1;
				}
			}
			return 0;
		}
		//como no tiene algo del tipo ref_xx, miro a ver si es del tipo recurso.
		else
		{			

			//obtengo todos los recursos de la BD
			$selectAllResources = "SELECT * FROM resource;";
			
			$allResources = mysql_query($selectAllResources, $this->conexion) or die(mysql_error());
			

			//busco si en los resultados, algun curso es como el que estoy buscando
			while ($rowAllResources = mysql_fetch_assoc($allResources)) 
			{
				//compruebo si en el path del recurso hay algo como filename
				if (substr_count($rowAllResources['path'],$filename) != 0)
				{	
					//lo ha encontrado, ahora compruebo que el curso al que pertenece					
					return 1;
				}
			}
			return 0;
		}
		//no lo he encontrado ni como curso ni como recurso, por lo tanto no tiene persimo. devuelve false
		return 0;
	}

	/** 
     * Funcion que comrpueba si un usuario existe en el sistema
     * @param login es el login del usuario
	 * @param password es el password del usuario
     */
	function checkUser($login,$password)
	{
		//busco si el usuario exsite en la base de datos
		$select = "SELECT * FROM student WHERE login='$login'";

		$student = mysql_query($select, $this->conexion) or die(mysql_error());

		//si el select no ha devuelto nada, el usuario no existe.

		if (mysql_affected_rows() == 0)
			return 0;

		$rowStudent = mysql_fetch_assoc($student);

		if ($password != $rowStudent['password'])
			return 0;

		//todo correcto, devuelvo true	
		return 1;
	}

	/** 
     * Funcion que comrpueba si un usuario se logeo por ultima vez hace mas tiempo que timePermitted
     * @param timePermitted es el tiempo permitido entre coenxiones
	 * @param login es el login del usuario
     */
	function checkLastAccess($login,$timePermitted)
	{
		//busco si el usuario exsite en la base de datos
		$select = "SELECT * FROM student WHERE login='$login'";

		$student = mysql_query($select, $this->conexion) or die(mysql_error());

		//si el select no ha devuelto nada, el usuario no existe.
		if(!$student)
			return 0;
	
		//obtengo la fecha de ultimo acceso del usuario
		$rowStudent = mysql_fetch_assoc($student);
		
		//resto la fecha actual menos la de ultimo acceso, si es mayor que timePermitted, devuelve 1
		$select2 = "SELECT UNIX_TIMESTAMP()-UNIX_TIMESTAMP('".$rowStudent['lastAccess']."')\"dif\"";

		$rowDif = mysql_query($select2, $this->conexion) or die(mysql_error());
		$row = mysql_fetch_assoc($rowDif);

		
		if ($row['dif'] > $timePermitted)
			return 1;
		else
			return 0;
	}

	/** 
     * Funcion que obtiene los cursos de un usuario
     * @param login es el login del usuario
	 * @return devuelve un array con los cursos del usuario
     */
	function getCourses($login)
	{
		$select = "SELECT * FROM student_course WHERE studentLogin ='$login';";
			
		$allCourses = mysql_query($select, $this->conexion) or die(mysql_error());
			
		//añado los cursos del alumno al array
		$cursos = array();
		while ($rowAllCourses = mysql_fetch_assoc($allCourses)) 			
			array_push($cursos,$rowAllCourses['courseId']);

		return $cursos;
	}

	/** 
     * Funcion que dada la referencia de un curso, devuelve su nombre
     * @param id es la referencia del curso
	 * @return devuelve el nombre del curso
     */
	function getNameOfCourse($refComplete)
	{
		list($ref, $id) = split('_', $refComplete);
		$select = "SELECT * from course WHERE id like $id";

			
		$consulta = mysql_query($select, $this->conexion) or die(mysql_error());
				
		$row = mysql_fetch_assoc($consulta);

		return $row['name'];
	}

	/** 
     * Funcion que consulta si un curso esta siendo actualizdo
     * @param refComplete es la referencia del curso
	 * @return 1 si esta siendo actualizado, 0 en otro caso
     */
	function getIfUpdatingCourse($refComplete)
	{
		list($ref, $id) = split('_', $refComplete);

		$select = 'select * from resource where idCourse like '.$id.' and updating = 1;';
			
		$consulta = mysql_query($select, $this->conexion) or die(mysql_error());
				
		if ($row = mysql_fetch_assoc($consulta))
			return 1;
		else
			return 0;

	}

	
	/** 
     * Funcion que consulta si un recurso esta siendo actualizdo
     * @param refComplete es la referencia del recurso
	 * @return 1 si esta siendo actualizado, 0 en otro caso
     */
	function getIfUpdatingResource($refComplete)
	{  
		list($ref, $id) = split('_', $refComplete);
		$select = 'SELECT updating FROM resource WHERE path like \'%'.$refComplete.'%\';';

		$consulta = mysql_query($select, $this->conexion) or die(mysql_error());
				
		$row = mysql_fetch_assoc($consulta);

		return $row['updating'];
	}

	/** 
     * Funcion que devuelve los cursos que estan siendo actualizados
     * @param id es el identificador del usuario
	 * @return devuelve un array con los identificadores de los cursos que están siendo actualizados
     */
	function getCoursesUpdating($id)
	{
		//obtengo los cursos del usuario
		$selectCoursesUser = "SELECT * FROM student_course WHERE studentLogin = '$id'";


		list($ref, $id) = split('_', $refComplete);
		$select = "SELECT * from course WHERE id like $id";

			
		$consulta = mysql_query($select, $this->conexion) or die(mysql_error());
				
		$row = mysql_fetch_assoc($consulta);

		return $row['name'];
	}


	/** 
     * Funcion que actualiza la fecha de ultimo acceso del usuario
     * @param login es el login del usuario a actualizar
	 * @return habrá actualizado la fecha de ultimo accesso con la fecha y hora actual siendo actualizados
     */
	function updateLastAccess($login)
	{
		//obtengo los cursos del usuario
		$update = "UPDATE student SET lastAccess=CURRENT_TIMESTAMP() WHERE login='$login';";

		mysql_query($update, $this->conexion) or die(mysql_error());				
	}

	/** 
     * Funcion que comprueba si un recurso es un directorio o no
     * @param $resource es el nombre del resource
	 * @return 1 si el recurso es un directorio, 0 en otro caso
     */
	function checkIfResourceIsDirectory($refComplete)
	{
		list($ref, $id) = split('_', $refComplete);
		$select = 'SELECT directory FROM resource WHERE path like \'%'.$refComplete.'%\';';
		$consulta = mysql_query($select, $this->conexion) or die(mysql_error());
				
		$row = mysql_fetch_assoc($consulta);


		if ($row['directory'] == 1)
			return 1;
		else
			return 0;
	}

	/** 
	 * Funcion que comprueba si hay algun curso actualizandose
	 * @return devuelve 1 en caso de que algún curso se esté actualizando, 0 en caso contrario
	 */
	function checkIfSomeCourseIsUpdating()
	{
		$select = "SELECT * FROM course WHERE updating = 1;";

		mysql_query($select, $this->conexion) or die(mysql_error());

		if (mysql_affected_rows() > 0)
			return 1;
		else
			return 0;
	}



	function writelog($message)
	{
/*		$fh = fopen('/var/www/log/bd.log', 'a');
		fwrite($fh, date('Y-m-d H:i:s '));
		fwrite($fh, $message);
		fwrite($fh, "\n");
		fclose($fh);*/
	}

}
